/*
 *
 *	SixPack is Copyright (C) 1996 Kaz Kylheku
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *	The author may be contacted at:
 *
 *	Kaz Kylheku
 *	2869 East 14th Avenue
 *	Vancouver, B.C.
 *	CANADA
 *	V5M 2H8
 *	email: kaz@cafe.net
 *
 */


#include <stdio.h>
#include "device.h"
#include "testdev.h"

int testdev_init(struct driver_s *driver)

{
	return 1;
}

void testdev_deinit(struct driver_s *driver)

{
}

int testdev_open(device_t dev, void *specific, va_list args)

{
	char *name = specific;
	FILE *fil = fopen(name, "r+");

	if (!fil)
		return 0;

	dev->handle.p = fil;

	return 1;
}

int testdev_close(device_t dev)

{
	return fclose(dev->handle.p) == 0;
}

int testdev_read(device_t dev, void *buf, size_t nbytes, size_t *nread)

{
	return ((*nread = fread(buf, 1, nbytes, dev->handle.p)) != 0);
}

int testdev_write(device_t dev, void *buf, size_t nbytes, size_t *nwrit)

{
	return ((*nwrit = fwrite(buf, 1, nbytes, dev->handle.p)) == nbytes);
}
